import sys, os
import shutil
import string
import random

import tempfile
import urllib.request

import pygame
import pygame.freetype
from pygame import *
from button import *

from color import *

##be told what database to use from the comand line
directories = ["Collection#1/"]
#in case i need to make temp files--a 'unique' session ID
letters = string.hexdigits
session = ''.join(random.choice(letters) for i in range(32)) #sessionpath = os.path.join(os.getcwd(), "." + session) #print(sessionpath) #os.mkdir(sessionpath)



## CONSTANTS - these change the function and output of the file. I am going to read them from config, but to play
# around, it is possible to set these directly

#recursion depth--cancel the password fetching algorithm if has recurs-ed this many times
MAX_DEPTH = 2

#base amount of errors to add password error count to. has splintering effect on each recursion
BASE_ERRORS = 0

#how many tiles of this pattern to display in one window
GRID_X = 1
GRID_Y = 2

#pixel width and height of window
size = width, height = 2000, 1400

config = True

if config == True:
	confList =[]
	configfile = open("settings.ini", encoding='utf-8')
	for line in configfile.readlines():
		if line[0] != "#":
			if "=" in line:
				confList.append(int(line.partition("=")[2]))
			else:
				print("empty config line...?")
	MAX_DEPTH = confList[0]
	BASE_ERRORS = confList[1]
	GRID_X = confList[2]
	GRID_Y = confList[3]
	width = confList[4]
	height = confList[5]
	size = width, height

##helper functions which do not require pygame
def getWorkingDir(inpaths):
	docpaths = []

	for dirs in directories:
		files = os.listdir(dirs)
		for item in files:
			docpaths.append( dirs + "" + item)		
	
	return docpaths[random.randint(0, len(docpaths) - 1)]

#print("Generating tiled carpet off of: " + getWorkingDir(directories))

#print(src_list)
activefile = open(getWorkingDir(directories), encoding='utf-8')
session_files = [line[:-1] for line in activefile.readlines()]
activefile.close()

def randEntry() -> str:
	return session_files[random.randint(0, len(session_files) - 1)]

def randUser() -> str:
	return randEntry.split(":")[0]

def splitToPassword(s) -> str:
	## this has become a match case..oosp
	k = ""
	if ':' in s:
		#print("case 1")
		k = s.split(":")[1] 
		
	elif ';' in s:

		#print("case 2")
		k = s.partition(";")[2] 
	else:
		#print("case 3")
			k=  s[:-5]
	
	if len(k) > 0:
		return k
	else:
		return s
##print(len(session_files))

def qualifyPasswordErrors(s):
	counter = BASE_ERRORS

	p = splitToPassword(s)

	if len(s) < 10:
		counter += 1
	if(not any(character in p for character in string.punctuation)):
		#print("NO SPECIAL CHARACTERS!!")
		counter += 1
	if(not any(character in p for character in string.ascii_uppercase)):
		#print("NOT EVEN ANY CAPITAL LETTERS???")
		counter += 1
	if(not any(character in p for character in string.digits)):
		#print("NO NUMBERS!!")
		counter += 1
	if counter == BASE_ERRORS:
		print("lucky catch " + p + " is actually safe")	
	return counter

#takes in a one element list
def populateStringList(l, depth):
	if l == []:
		#print("failed \n")
		return [populateStringList(randEntry(), 0)]
	else:
		counter = qualifyPasswordErrors(l)
		#control Shape of recursion by having one temp var here, for loop to add lists to it with each iteration	
		if(counter > 0 and depth < MAX_DEPTH):
			concat = [l]
			for i in range(1,counter+1):
				concat += [populateStringList(randEntry(), depth + 1)]
			return concat
		else:
			return [l]

 
session_strings = populateStringList([], 0)
#print(session_strings)


##
##pygame begins here
##
##
pygame.init()

pygame.display.set_caption('PASSWORD TEXTILES')

screen = pygame.display.set_mode(size)

def paletteGen(s) -> list:
	n = len(s)
	passpalette = paletteFromString(splitToPassword(s) ,3)
	#print("string " + s + " creates palette of size " +str(len(passpalette)))
	return [passpalette[i % len(passpalette)] for i in range(n)]  
drawn = False

def textchain(s, palette:list, x_bounds: tuple, y_bounds : tuple):
	global drawn

	if not drawn:
		pygame.display.set_caption(pygame.display.get_caption()[0] + " " +  s)

		ywidth = y_bounds[1] - y_bounds[0]
		divisionsy = len(s)
		fontsize = ( (ywidth/divisionsy )  ,  (x_bounds[1] - x_bounds[0]) * .6)

		c = pygame.freetype.SysFont("Consolas", fontsize)
		c.vertical = True
		i = 0
		#print(len(s))
		for char in s:
			i+=1
			#c.render_to(screen, (x_bounds[0], int(height * (i - 1)/divisionsy)), char, palette[i-1] )
			c.render_to(screen, (int(y_bounds[0] + (ywidth ) * (i - 1)/divisionsy), x_bounds[0] ), char, palette[i - 1] )
		#c.render_to(screen, (x_bounds[0], int(height * (i - 1)/divisionsy)), s, palette[i-1])
		


def recursiveRect(l, x_bounds: tuple, y_bounds: tuple):
	#list of lists (unknown how many layers of depth ), 
	#x_bounds 
	#global PEOPLECOUNTER 
	global drawn

	cwidth = int((x_bounds[1] - x_bounds[0]) / len(l) + 2	)
	#if it contains other lists and is not a string
	if( len(l) > 1 and not isinstance(l, str)):
		drawn = False
		counter = 1

		for column in l:
			counter += 1
			cpos = x_bounds[0] + int( ( (cwidth + 2) * counter) / len(l))

			#print(" Column no. " + str(counter) +  " is being gone through...")
			
			recursiveRect(column, ( cpos  , cpos + cwidth ),  y_bounds )
			
	#if is a string	
	elif( len(l) > 1):
		drawn = False
		boardPalette = paletteGen(l)
		#print(len(boardPalette))
		
		randPositions = [random.randint(0, len(boardPalette) - 1) for i in range(3)]
		noiseColor = tuple( (sum(boardPalette[i][n] for i in randPositions) // 3)  for n in range(3))

		pygame.draw.rect(screen, noiseColor, [(y_bounds[0], x_bounds[0] ),(y_bounds[1]-y_bounds[0], x_bounds[1]-x_bounds[0])] )
		
		textchain(l, boardPalette, x_bounds, y_bounds)	
		drawn = True
	#if it is one singular column, send in the string
	else: 
		recursiveRect(l[0], x_bounds, y_bounds)
		
	



def drawScreen(l):
	localheight = height * (1 + (.76 * (GRID_Y - 1)))
	#print(1 + (.76 * (GRID_Y - 1)))


	for wrapper in l:
		counter = 0
		for column in wrapper:
			#recursiveRect(column, (0, int(height * (3))), (0, width/2) )
			#recursiveRect(populateStringList([], 0), (0, int(height * (3))), (width/2, width) )
			#recursiveRect(column, (int(height * (7/14)), int(height * (12/13))))
			for x in range(0, GRID_X):
				for y in range(0, GRID_Y):
					recursiveRect(populateStringList([], 0), ( int((y * height)/GRID_Y), int(((y + 1) * localheight)/GRID_Y)  ), ( ((x * width) )/GRID_X, (( (x+1) * width)/GRID_X) ) )
			
			#recursiveRect(populateStringList([], 0), (0/GRID_Y, (width/GRID_Y)), (0/GRID_X, ((height)/GRID_X) ))
						
			#print("draw call")
	#print(PEOPLECOUNTER)
	#PEOPLECOUNTER = 0

h_menu_bar = height / 19 

#list of buttons
#each button has vars (x bounds), (y bounds), (event call)
h_menu = []
style_x_width = width/9


drawScreen(session_strings)

def reload():

	#global PEOPLECOUNTER 
	#PEOPLECOUNTER = 0
	global session_strings 
	global drawn
	global bar
	drawn = False
	session_strings = populateStringList([], 0)
	
def drawMenu():
	pygame.draw.rect(screen, (130,127,127), [(0, height - h_menu_bar), (width, h_menu_bar)])		 
	pygame.draw.rect(screen, (190,190,190), [(width/3 - style_x_width, height - h_menu_bar), (style_x_width, height)])

#MENU BAR
drawMenu()


#a button within these coords whose action is to reload all of the passwords
redrawNames = Button( (width/3 - style_x_width, width/3), ((10 * height) / 11, height), reload )
h_menu.append( UI_Button(redrawNames, "draw again") )





##
## PYGAME RENDER LOOP
## THERE'S NO GOING BACK NOW
## IF IT'S NOT A GLOBAL VARIABLE, GOOD LUCK
while True:
	#screen.fill( (0,0,0) )
		
	for event in pygame.event.get():

		mouse = pygame.mouse.get_pos()

		if event.type == pygame.QUIT: sys.exit()
		if event.type == pygame.MOUSEBUTTONUP:
			pygame.draw.rect(screen, (255,10,10), [(width/3 - style_x_width, height - h_menu_bar), (style_x_width, height)])
			
			drawScreen(session_strings)
			drawMenu()
			#print(session_strings)
		#lets only redraw when theres something to update
			
		if event.type == pygame.MOUSEBUTTONDOWN and mouse[1] > height-h_menu_bar:
			#print("TEST")
			for uibutton in h_menu:
				button = uibutton.button
				if(button.withinRange( mouse[0], mouse[1] )):
					button.act()
														
	#GRAPHICS-ONLY UPDATE ON CHANGE OF SETTINGS

				#todo
				


	pygame.display.update()
	#screen.fill( (255,255,255) )
#end

##urllib.request.urlopen('https://haveibeenpwned.com/api/v2/breachedaccount/' + session_files[random.randint(0, len(session_files) - 1)].split(':')[0] )

#headers = {'hibp-api-key': user_agent}
#request = urllib.request.Request('https://haveibeenpwned.com/api/v3/breachedaccount/', thisuser.split(':')[0].encode('ascii'), headers)

#with urllib.request.urlopen(request) as response:
#	the_page = response.read()
